Package com.sas.metadata.remote

# Interface OLAPProperty

All Superinterfaces:
  `CMetadata`, `Feature`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface OLAPProperty extends Feature
An attribute associated with members of a given dimension level. It is a feature of a Dimension, and can associated with a Level, and to a Column through a FeatureMap.

Attributes of OLAPProperty are:

- `SASFormat`

Associations of OLAPProperty are:

- `Hierarchies`
- `AssociatedLevel`

## Usage

To create an instance of this OLAPProperty, use the `factory` create methods.
Example: create a OLAPProperty with name "OLAPProperty_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     OLAPProperty myObject = (OLAPProperty) factory.createComplexMetadataObject(objectStore, "OLAPProperty_Object", MetadataObjects.OLAPPROPERTY, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDLEVEL_NAME`
  Constant used for the name of the AssociatedLevel association.
  `static final String`
  `ASSOCIATION_HIERARCHIES_NAME`
  Constant used for the name of the Hierarchies association.
  `static final String`
  `ATTRIBUTE_SASFORMAT_NAME`
  Constant used for the name of the SASFormat attribute.

  ### Fields inherited from interface com.sas.metadata.remote.Feature

  `ASSOCIATION_SOURCEFEATUREMAPS_NAME, ASSOCIATION_TARGETFEATUREMAPS_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Level`
  `getAssociatedLevel()`
  Gets the `Level` for `AssociatedLevel`
  `AssociationList`
  `getAssociatedLevels()`
  Gets the Association list of `AssociatedLevels`
  `AssociationList`
  `getAssociatedLevels(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedLevels`
  `AssociationList`
  `getHierarchies()`
  Gets the AssociationList of `Hierarchies`
  `AssociationList`
  `getHierarchies(boolean fGoToServer)`
  Gets the Associationlist of `Hierarchies`
  `String`
  `getSASFormat()`
  Gets the `String` value of `SASFormat`
  `int`
  `getSASFormatMaxLength()`
  Gets the maximum length of `SASFormat`
  `int`
  `getSASFormatState()`
  Gets the Metadata State of `SASFormat`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `Hierarchies`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAssociatedLevel(Level inObject)`
  Sets the `AssociatedLevels` list 0th element to be `inObject`.
  `void`
  `setAssociatedLevels(AssociationList list)`
  Sets the `AssociatedLevels` list to be `list`.
  `void`
  `setAssociatedLevels(AssociationList list, int state)`
  Sets the `AssociatedLevels` list to be `list`.
  `void`
  `setHierarchies(AssociationList list)`
  Sets the `Hierarchies` list to be `list`.
  `void`
  `setHierarchies(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setSASFormat(String inSASFormat)`
  Sets the `SASFormat` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSASFormat(String inSASFormat, int state)`
  Sets the `SASFormat` Metadata State.
  `void`
  `setSASFormatState(int state)`
  Sets the Metadata State of `SASFormat`.

  ### Methods inherited from interface com.sas.metadata.remote.Feature

  `getSourceFeatureMaps, getSourceFeatureMaps, getTargetFeatureMaps, getTargetFeatureMaps, setSourceFeatureMaps, setSourceFeatureMaps, setTargetFeatureMaps, setTargetFeatureMaps`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_SASFORMAT_NAME

    static final String ATTRIBUTE_SASFORMAT_NAME
    Constant used for the name of the SASFormat attribute.

    SASFormat: SASFormat

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_HIERARCHIES_NAME

    static final String ASSOCIATION_HIERARCHIES_NAME
    Constant used for the name of the Hierarchies association.

    Hierarchies: The hierarchies associated to this OLAP property.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDLEVEL_NAME

    static final String ASSOCIATION_ASSOCIATEDLEVEL_NAME
    Constant used for the name of the AssociatedLevel association.

    AssociatedLevel: The level associated to this OLAP property.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `Feature`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `Hierarchies`
    Specified by:
      `initializePredObjects` in interface `Feature`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSASFormat

    String getSASFormat() throws RemoteException
    Gets the `String` value of `SASFormat`
    Returns:
      The `SASFormat`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSASFormatState

    int getSASFormatState() throws RemoteException
    Gets the Metadata State of `SASFormat`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSASFormatMaxLength

    int getSASFormatMaxLength() throws RemoteException
    Gets the maximum length of `SASFormat`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getHierarchies

    AssociationList getHierarchies() throws RemoteException, MdException
    Gets the AssociationList of `Hierarchies`
    Returns:
      Returns the AssociationList of `Hierarchies` which can be of type:
      Hierarchy
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedLevels

    AssociationList getAssociatedLevels() throws RemoteException, MdException
    Gets the Association list of `AssociatedLevels`
    Returns:
      The AssociationList of `AssociatedLevels` which can be of type:
      Level
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedLevel

    Level getAssociatedLevel() throws RemoteException, MdException
    Gets the `Level` for `AssociatedLevel`
    Returns:
      The `Level` ( `null` if not set ) of `AssociatedLevel` which can be of type:
      Level
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getHierarchies

    AssociationList getHierarchies(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Hierarchies`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Hierarchies` which can be of type:
      Hierarchy
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedLevels

    AssociationList getAssociatedLevels(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedLevels`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `AssociatedLevels` which can be of type:
      Level
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setSASFormat

    void setSASFormat(String inSASFormat) throws RemoteException
    Sets the `SASFormat` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSASFormat` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSASFormat

    void setSASFormat(String inSASFormat, int state) throws RemoteException
    Sets the `SASFormat` Metadata State.
    Parameters:
      `inSASFormat` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSASFormatState

    void setSASFormatState(int state) throws RemoteException
    Sets the Metadata State of `SASFormat`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchies

    void setHierarchies(AssociationList list) throws RemoteException
    Sets the `Hierarchies` list to be `list`. Objects of which can be of type:
    Hierarchy
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchies

    void setHierarchies(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedLevels

    void setAssociatedLevels(AssociationList list) throws RemoteException
    Sets the `AssociatedLevels` list to be `list`. Objects of which can be of type:
    Level
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedLevels

    void setAssociatedLevels(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedLevels` list to be `list`. Objects of which can be of type:
    Level
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedLevel

    void setAssociatedLevel(Level inObject) throws RemoteException
    Sets the `AssociatedLevels` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Level
    Throws:
      `RemoteException` - If error communicating with remote object.